diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -8343,12 +3678,14 @@ test_canonicalization_4 ()
 
 static void
 assert_region_models_merge (tree expr, tree val_a, tree val_b,
-			    region_model *out_merged_model,
-			    svalue **out_merged_svalue)
+			     region_model *out_merged_model,
+			     const svalue **out_merged_svalue)
 {
+  program_point point (program_point::origin ());
   test_region_model_context ctxt;
-  region_model model0;
-  region_model model1;
+  region_model_manager *mgr = out_merged_model->get_manager ();
+  region_model model0 (mgr);
+  region_model model1 (mgr);
   if (val_a)
     model0.set_value (model0.get_lvalue (expr, &ctxt),
 		      model0.get_rvalue (val_a, &ctxt),
@@ -8359,10 +3696,8 @@ assert_region_models_merge (tree expr, tree val_a, tree val_b,
 		      &ctxt);
 
   /* They should be mergeable.  */
-  ASSERT_TRUE (model0.can_merge_with_p (model1, out_merged_model));
-
-  svalue_id merged_svalue_sid = out_merged_model->get_rvalue (expr, &ctxt);
-  *out_merged_svalue = out_merged_model->get_svalue (merged_svalue_sid);
+  ASSERT_TRUE (model0.can_merge_with_p (model1, point, out_merged_model));
+  *out_merged_svalue = out_merged_model->get_rvalue (expr, &ctxt);
 }
 
 /* Verify that we can merge region_model instances.  */
@@ -8395,12 +3730,15 @@ test_state_merging ()
 		       get_identifier ("q"),
 		       ptr_type_node);
 
+  program_point point (program_point::origin ());
+  region_model_manager mgr;
+
   {
-    region_model model0;
-    region_model model1;
-    region_model merged;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
+    region_model merged (&mgr);
     /* Verify empty models can be merged.  */
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
   }
 
@@ -8409,13 +3747,13 @@ test_state_merging ()
   /* TODO: verify that the merged model doesn't have a value for
      the global  */
   {
-    region_model model0;
-    region_model model1;
-    region_model merged;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
+    region_model merged (&mgr);
     test_region_model_context ctxt;
     model0.add_constraint (x, EQ_EXPR, int_42, &ctxt);
     model1.add_constraint (x, EQ_EXPR, int_113, &ctxt);
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_NE (model0, merged);
     ASSERT_NE (model1, merged);
   }
@@ -8423,64 +3761,51 @@ test_state_merging ()
   /* Verify handling of a PARM_DECL.  */
   {
     test_region_model_context ctxt;
-    region_model model0;
-    region_model model1;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
     ASSERT_EQ (model0.get_stack_depth (), 0);
     model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, &ctxt);
     ASSERT_EQ (model0.get_stack_depth (), 1);
-    ASSERT_EQ (model0.get_function_at_depth (0),
-	       DECL_STRUCT_FUNCTION (test_fndecl));
     model1.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, &ctxt);
 
-    svalue_id sid_a
-      = model0.set_to_new_unknown_value (model0.get_lvalue (a, &ctxt),
-					 integer_type_node, &ctxt);
-    model1.set_to_new_unknown_value (model1.get_lvalue (a, &ctxt),
-				     integer_type_node, &ctxt);
+    placeholder_svalue test_sval (integer_type_node, "test sval");
+    model0.set_value (model0.get_lvalue (a, &ctxt), &test_sval, &ctxt);
+    model1.set_value (model1.get_lvalue (a, &ctxt), &test_sval, &ctxt);
     ASSERT_EQ (model0, model1);
 
-    /* Check that get_value_by_name works for locals.  */
-    ASSERT_EQ (model0.get_value_by_name ("a"), sid_a);
-
     /* They should be mergeable, and the result should be the same.  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
-    /* In particular, there should be an unknown value for "a".  */
-    svalue *merged_a_sval = merged.get_svalue (merged.get_rvalue (a, &ctxt));
-    ASSERT_EQ (merged_a_sval->get_kind (), SK_UNKNOWN);
+    /* In particular, "a" should have the placeholder value.  */
+    ASSERT_EQ (merged.get_rvalue (a, &ctxt), &test_sval);
   }
 
   /* Verify handling of a global.  */
   {
     test_region_model_context ctxt;
-    region_model model0;
-    region_model model1;
-    svalue_id sid_x
-      = model0.set_to_new_unknown_value (model0.get_lvalue (x, &ctxt),
-					 integer_type_node, &ctxt);
-    model1.set_to_new_unknown_value (model1.get_lvalue (x, &ctxt),
-				     integer_type_node, &ctxt);
-    ASSERT_EQ (model0, model1);
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
 
-    /* Check that get_value_by_name works for globals.  */
-    ASSERT_EQ (model0.get_value_by_name ("x"), sid_x);
+    placeholder_svalue test_sval (integer_type_node, "test sval");
+    model0.set_value (model0.get_lvalue (x, &ctxt), &test_sval, &ctxt);
+    model1.set_value (model1.get_lvalue (x, &ctxt), &test_sval, &ctxt);
+    ASSERT_EQ (model0, model1);
 
     /* They should be mergeable, and the result should be the same.  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
-    /* In particular, there should be an unknown value for "x".  */
-    svalue *merged_x_sval = merged.get_svalue (merged.get_rvalue (x, &ctxt));
-    ASSERT_EQ (merged_x_sval->get_kind (), SK_UNKNOWN);
+    /* In particular, "x" should have the placeholder value.  */
+    ASSERT_EQ (merged.get_rvalue (x, &ctxt), &test_sval);
   }
 
   /* Use global-handling to verify various combinations of values.  */
 
   /* Two equal constant values.  */
   {
-    region_model merged;
-    svalue *merged_x_sval;
+    region_model merged (&mgr);
+    const svalue *merged_x_sval;
     assert_region_models_merge (x, int_42, int_42, &merged, &merged_x_sval);
 
     /* In particular, there should be a constant value for "x".  */
@@ -8491,28 +3816,28 @@ test_state_merging ()
 
   /* Two non-equal constant values.  */
   {
-    region_model merged;
-    svalue *merged_x_sval;
+    region_model merged (&mgr);
+    const svalue *merged_x_sval;
     assert_region_models_merge (x, int_42, int_113, &merged, &merged_x_sval);
 
-    /* In particular, there should be an unknown value for "x".  */
-    ASSERT_EQ (merged_x_sval->get_kind (), SK_UNKNOWN);
+    /* In particular, there should be a "widening" value for "x".  */
+    ASSERT_EQ (merged_x_sval->get_kind (), SK_WIDENING);
   }
 
-  /* Uninit and constant.  */
+  /* Initial and constant.  */
   {
-    region_model merged;
-    svalue *merged_x_sval;
+    region_model merged (&mgr);
+    const svalue *merged_x_sval;
     assert_region_models_merge (x, NULL_TREE, int_113, &merged, &merged_x_sval);
 
     /* In particular, there should be an unknown value for "x".  */
     ASSERT_EQ (merged_x_sval->get_kind (), SK_UNKNOWN);
   }
 
-  /* Constant and uninit.  */
+  /* Constant and initial.  */
   {
-    region_model merged;
-    svalue *merged_x_sval;
+    region_model merged (&mgr);
+    const svalue *merged_x_sval;
     assert_region_models_merge (x, int_42, NULL_TREE, &merged, &merged_x_sval);
 
     /* In particular, there should be an unknown value for "x".  */
@@ -8530,10 +3855,8 @@ test_state_merging ()
 
   /* Pointers: non-NULL and non-NULL: ptr to a local.  */
   {
-    region_model model0;
+    region_model model0 (&mgr);
     model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
-    model0.set_to_new_unknown_value (model0.get_lvalue (a, NULL),
-				     integer_type_node, NULL);
     model0.set_value (model0.get_lvalue (p, NULL),
 		      model0.get_rvalue (addr_of_a, NULL), NULL);
 
@@ -8541,31 +3864,34 @@ test_state_merging ()
     ASSERT_EQ (model0, model1);
 
     /* They should be mergeable, and the result should be the same.  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
   }
 
   /* Pointers: non-NULL and non-NULL: ptr to a global.  */
   {
-    region_model merged;
+    region_model merged (&mgr);
     /* p == &y in both input models.  */
-    svalue *merged_p_sval;
+    const svalue *merged_p_sval;
     assert_region_models_merge (p, addr_of_y, addr_of_y, &merged,
 				&merged_p_sval);
 
     /* We should get p == &y in the merged model.  */
     ASSERT_EQ (merged_p_sval->get_kind (), SK_REGION);
-    region_svalue *merged_p_ptr = merged_p_sval->dyn_cast_region_svalue ();
-    region_id merged_p_star_rid = merged_p_ptr->get_pointee ();
-    ASSERT_EQ (merged_p_star_rid, merged.get_lvalue (y, NULL));
+    const region_svalue *merged_p_ptr
+      = merged_p_sval->dyn_cast_region_svalue ();
+    const region *merged_p_star_reg = merged_p_ptr->get_pointee ();
+    ASSERT_EQ (merged_p_star_reg, merged.get_lvalue (y, NULL));
   }
 
   /* Pointers: non-NULL ptrs to different globals: should be unknown.  */
   {
-    region_model merged;
-    /* x == &y vs x == &z in the input models.  */
-    svalue *merged_x_sval;
+    region_model merged (&mgr);
+    /* x == &y vs x == &z in the input models; these are actually casts
+       of the ptrs to "int".  */
+    const svalue *merged_x_sval;
+    // TODO:
     assert_region_models_merge (x, addr_of_y, addr_of_z, &merged,
 				&merged_x_sval);
 
@@ -8576,42 +3902,39 @@ test_state_merging ()
   /* Pointers: non-NULL and non-NULL: ptr to a heap region.  */
   {
     test_region_model_context ctxt;
-    region_model model0;
-    region_id new_rid = model0.add_new_malloc_region ();
-    svalue_id ptr_sid
-      = model0.get_or_create_ptr_svalue (ptr_type_node, new_rid);
+    region_model model0 (&mgr);
+    tree size = build_int_cst (integer_type_node, 1024);
+    const svalue *size_sval = mgr.get_or_create_constant_svalue (size);
+    const region *new_reg = model0.create_region_for_heap_alloc (size_sval);
+    const svalue *ptr_sval = mgr.get_ptr_svalue (ptr_type_node, new_reg);
     model0.set_value (model0.get_lvalue (p, &ctxt),
-		      ptr_sid, &ctxt);
-    model0.canonicalize (&ctxt);
+		      ptr_sval, &ctxt);
 
     region_model model1 (model0);
 
     ASSERT_EQ (model0, model1);
 
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
 
-    merged.canonicalize (&ctxt);
-
-    /* The merged model ought to be identical (after canonicalization,
-       at least).  */
+    /* The merged model ought to be identical.  */
     ASSERT_EQ (model0, merged);
   }
 
-  /* Two regions sharing the same unknown svalue should continue sharing
-     an unknown svalue after self-merger.  */
+  /* Two regions sharing the same placeholder svalue should continue sharing
+     it after self-merger.  */
   {
     test_region_model_context ctxt;
-    region_model model0;
-    svalue_id sid
-      = model0.set_to_new_unknown_value (model0.get_lvalue (x, &ctxt),
-					 integer_type_node, &ctxt);
-    model0.set_value (model0.get_lvalue (y, &ctxt), sid, &ctxt);
+    region_model model0 (&mgr);
+    placeholder_svalue placeholder_sval (integer_type_node, "test");
+    model0.set_value (model0.get_lvalue (x, &ctxt),
+		      &placeholder_sval, &ctxt);
+    model0.set_value (model0.get_lvalue (y, &ctxt), &placeholder_sval, &ctxt);
     region_model model1 (model0);
 
     /* They should be mergeable, and the result should be the same.  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
 
     /* In particular, we should have x == y.  */
@@ -8619,26 +3942,26 @@ test_state_merging ()
 	       tristate (tristate::TS_TRUE));
   }
 
-#if 0
   {
-    region_model model0;
-    region_model model1;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
     test_region_model_context ctxt;
     model0.add_constraint (x, EQ_EXPR, int_42, &ctxt);
     model1.add_constraint (x, NE_EXPR, int_42, &ctxt);
-    ASSERT_TRUE (model0.can_merge_with_p (model1));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
   }
 
   {
-    region_model model0;
-    region_model model1;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
     test_region_model_context ctxt;
     model0.add_constraint (x, EQ_EXPR, int_42, &ctxt);
     model1.add_constraint (x, NE_EXPR, int_42, &ctxt);
     model1.add_constraint (x, EQ_EXPR, int_113, &ctxt);
-    ASSERT_TRUE (model0.can_merge_with_p (model1));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
   }
-#endif
 
   // TODO: what can't we merge? need at least one such test
 
@@ -8646,78 +3969,74 @@ test_state_merging ()
      - heap regions
      - value merging:
        - every combination, but in particular
-          - pairs of regions
+	   - pairs of regions
    */
 
   /* Views.  */
   {
     test_region_model_context ctxt;
-    region_model model0;
+    region_model model0 (&mgr);
 
-    region_id x_rid = model0.get_lvalue (x, &ctxt);
-    region_id x_as_ptr = model0.get_or_create_view (x_rid, ptr_type_node,
-						    &ctxt);
+    const region *x_reg = model0.get_lvalue (x, &ctxt);
+    const region *x_as_ptr = mgr.get_cast_region (x_reg, ptr_type_node);
     model0.set_value (x_as_ptr, model0.get_rvalue (addr_of_y, &ctxt), &ctxt);
 
     region_model model1 (model0);
     ASSERT_EQ (model1, model0);
 
     /* They should be mergeable, and the result should be the same.  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
   }
 
   /* Verify that we can merge a model in which a local in an older stack
      frame points to a local in a more recent stack frame.  */
   {
-    region_model model0;
+    region_model model0 (&mgr);
     model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
-    region_id q_in_first_frame = model0.get_lvalue (q, NULL);
+    const region *q_in_first_frame = model0.get_lvalue (q, NULL);
 
     /* Push a second frame.  */
-    region_id rid_2nd_frame
+    const region *reg_2nd_frame
       = model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
 
     /* Have a pointer in the older frame point to a local in the
        more recent frame.  */
-    svalue_id sid_ptr = model0.get_rvalue (addr_of_a, NULL);
-    model0.set_value (q_in_first_frame, sid_ptr, NULL);
+    const svalue *sval_ptr = model0.get_rvalue (addr_of_a, NULL);
+    model0.set_value (q_in_first_frame, sval_ptr, NULL);
 
     /* Verify that it's pointing at the newer frame.  */
-    region_id rid_pointee
-      = model0.get_svalue (sid_ptr)->dyn_cast_region_svalue ()->get_pointee ();
-    ASSERT_EQ (model0.get_region (rid_pointee)->get_parent (), rid_2nd_frame);
+    const region *reg_pointee
+      = sval_ptr->dyn_cast_region_svalue ()->get_pointee ();
+    ASSERT_EQ (reg_pointee->get_parent_region (), reg_2nd_frame);
 
-    model0.canonicalize (NULL);
+    model0.canonicalize ();
 
     region_model model1 (model0);
     ASSERT_EQ (model0, model1);
 
     /* They should be mergeable, and the result should be the same
        (after canonicalization, at least).  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
-    merged.canonicalize (NULL);
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
+    merged.canonicalize ();
     ASSERT_EQ (model0, merged);
   }
 
   /* Verify that we can merge a model in which a local points to a global.  */
   {
-    region_model model0;
+    region_model model0 (&mgr);
     model0.push_frame (DECL_STRUCT_FUNCTION (test_fndecl), NULL, NULL);
     model0.set_value (model0.get_lvalue (q, NULL),
 		      model0.get_rvalue (addr_of_y, NULL), NULL);
 
-    model0.canonicalize (NULL);
-
     region_model model1 (model0);
     ASSERT_EQ (model0, model1);
 
     /* They should be mergeable, and the result should be the same
        (after canonicalization, at least).  */
-    region_model merged;
-    ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
-    merged.canonicalize (NULL);
+    region_model merged (&mgr);
+    ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
     ASSERT_EQ (model0, merged);
   }
 }
@@ -8735,28 +4054,26 @@ test_constraint_merging ()
   tree z = build_global_decl ("z", integer_type_node);
   tree n = build_global_decl ("n", integer_type_node);
 
+  region_model_manager mgr;
   test_region_model_context ctxt;
 
   /* model0: 0 <= (x == y) < n.  */
-  region_model model0;
-  model0.set_to_new_unknown_value (model0.get_lvalue (x, &ctxt),
-				   integer_type_node, &ctxt);
+  region_model model0 (&mgr);
   model0.add_constraint (x, EQ_EXPR, y, &ctxt);
   model0.add_constraint (x, GE_EXPR, int_0, NULL);
   model0.add_constraint (x, LT_EXPR, n, NULL);
 
   /* model1: z != 5 && (0 <= x < n).  */
-  region_model model1;
-  model1.set_to_new_unknown_value (model1.get_lvalue (x, &ctxt),
-				   integer_type_node, &ctxt);
+  region_model model1 (&mgr);
   model1.add_constraint (z, NE_EXPR, int_5, NULL);
   model1.add_constraint (x, GE_EXPR, int_0, NULL);
   model1.add_constraint (x, LT_EXPR, n, NULL);
 
   /* They should be mergeable; the merged constraints should
      be: (0 <= x < n).  */
-  region_model merged;
-  ASSERT_TRUE (model0.can_merge_with_p (model1, &merged));
+  program_point point (program_point::origin ());
+  region_model merged (&mgr);
+  ASSERT_TRUE (model0.can_merge_with_p (model1, point, &merged));
 
   ASSERT_EQ (merged.eval_condition (x, GE_EXPR, int_0, &ctxt),
 	     tristate (tristate::TS_TRUE));
@@ -8769,29 +4086,243 @@ test_constraint_merging ()
 	     tristate (tristate::TS_UNKNOWN));
 }
 
+/* FIXME.  */
+
+static void
+test_widening_constraints ()
+{
+  program_point point (program_point::origin ());
+  tree int_0 = build_int_cst (integer_type_node, 0);
+  tree int_m1 = build_int_cst (integer_type_node, -1);
+  tree int_1 = build_int_cst (integer_type_node, 1);
+  tree int_256 = build_int_cst (integer_type_node, 256);
+  region_model_manager mgr;
+  test_region_model_context ctxt;
+  const svalue *int_0_sval = mgr.get_or_create_constant_svalue (int_0);
+  const svalue *int_1_sval = mgr.get_or_create_constant_svalue (int_1);
+  const svalue *w_zero_then_one_sval
+    = mgr.get_or_create_widening_svalue (integer_type_node, point,
+					  int_0_sval, int_1_sval);
+  const widening_svalue *w_zero_then_one
+    = w_zero_then_one_sval->dyn_cast_widening_svalue ();
+  ASSERT_EQ (w_zero_then_one->get_direction (),
+	     widening_svalue::DIR_ASCENDING);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LT_EXPR, int_m1),
+	     tristate::TS_FALSE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LT_EXPR, int_0),
+	     tristate::TS_FALSE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LT_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LT_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LE_EXPR, int_m1),
+	     tristate::TS_FALSE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LE_EXPR, int_0),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LE_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (LE_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GT_EXPR, int_m1),
+	     tristate::TS_TRUE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GT_EXPR, int_0),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GT_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GT_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GE_EXPR, int_m1),
+	     tristate::TS_TRUE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GE_EXPR, int_0),
+	     tristate::TS_TRUE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GE_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (GE_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (EQ_EXPR, int_m1),
+	     tristate::TS_FALSE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (EQ_EXPR, int_0),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (EQ_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (EQ_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (NE_EXPR, int_m1),
+	     tristate::TS_TRUE);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (NE_EXPR, int_0),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (NE_EXPR, int_1),
+	     tristate::TS_UNKNOWN);
+  ASSERT_EQ (w_zero_then_one->eval_condition_without_cm (NE_EXPR, int_256),
+	     tristate::TS_UNKNOWN);
+
+  // TODO: a descending value
+}
+
+/* Verify merging constraints for states simulating successive iterations
+   of a loop.
+   Simulate:
+     for (i = 0; i < 256; i++)
+       [...body...]
+   i.e. this gimple:.
+     i_15 = 0;
+     goto <bb 4>;
+
+   <bb 4> :
+     i_11 = PHI <i_15(2), i_23(3)>
+     if (i_11 <= 255)
+       goto <bb 3>;
+     else
+       goto [AFTER LOOP]
+
+   <bb 3> :
+     [LOOP BODY]
+     i_23 = i_11 + 1;
+
+   and thus these ops (and resultant states):
+     i_11 = PHI()
+       {i_11: 0}
+     add_constraint (i_11 <= 255) [for the true edge]
+       {i_11: 0}  [constraint was a no-op]
+     i_23 = i_11 + 1;
+       {i_22: 1}
+     i_11 = PHI()
+       {i_11: WIDENED (at phi, 0, 1)}
+     add_constraint (i_11 <= 255) [for the true edge]
+       {i_11: WIDENED (at phi, 0, 1); WIDENED <= 255}
+     i_23 = i_11 + 1;
+       {i_23: (WIDENED (at phi, 0, 1) + 1); WIDENED <= 255}
+     i_11 = PHI(); merge with state at phi above
+       {i_11: WIDENED (at phi, 0, 1); WIDENED <= 256}
+         [changing meaning of "WIDENED" here]
+     if (i_11 <= 255)
+        T: {i_11: WIDENED (at phi, 0, 1); WIDENED <= 255}; cache hit
+        F: {i_11: 256}
+
+	FIXME.
+	TODO: rename?
+ */
+
+static void
+test_iteration_1 ()
+{
+  program_point point (program_point::origin ());
+
+  tree int_0 = build_int_cst (integer_type_node, 0);
+  tree int_1 = build_int_cst (integer_type_node, 1);
+  tree int_256 = build_int_cst (integer_type_node, 256);
+  tree int_257 = build_int_cst (integer_type_node, 257);
+  tree i = build_global_decl ("i", integer_type_node);
+
+  region_model_manager mgr;
+  test_region_model_context ctxt;
+
+  /* model0: i: 0.  */
+  region_model model0 (&mgr);
+  model0.set_value (i, int_0, &ctxt);
+
+  /* model1: i: 1.  */
+  region_model model1 (&mgr);
+  model1.set_value (i, int_1, &ctxt);
+
+  /* FIXME: should merge to a widened value.  */
+  region_model model2 (&mgr);
+  ASSERT_TRUE (model1.can_merge_with_p (model0, point, &model2));
+  const svalue *merged_i = model2.get_rvalue (i, &ctxt);
+  ASSERT_EQ (merged_i->get_kind (), SK_WIDENING);
+  const widening_svalue *w = merged_i->dyn_cast_widening_svalue ();
+  ASSERT_EQ (w->get_direction (), widening_svalue::DIR_ASCENDING);
+
+  /* Add constraint: i < 256  */
+  model2.add_constraint (i, LT_EXPR, int_256, &ctxt);
+  ASSERT_EQ (model2.eval_condition (i, LT_EXPR, int_256, &ctxt),
+	     tristate (tristate::TS_TRUE));
+  ASSERT_EQ (model2.eval_condition (i, GE_EXPR, int_0, &ctxt),
+	     tristate (tristate::TS_TRUE));
+
+  /* Try merging with the initial state.  */
+  region_model model3 (&mgr);
+  ASSERT_TRUE (model2.can_merge_with_p (model0, point, &model3));
+  /* Merging the merged value with the initial value should be idempotent,
+     so that the analysis converges.  */
+  ASSERT_EQ (model3.get_rvalue (i, &ctxt), merged_i);
+  /* Merger of 0 and a widening value with constraint < CST
+     should retain the constraint, even though it was implicit
+     for the 0 case.  */
+  ASSERT_EQ (model3.eval_condition (i, LT_EXPR, int_256, &ctxt),
+	     tristate (tristate::TS_TRUE));
+  /* ...and we should have equality: the analysis should have converged.  */
+  ASSERT_EQ (model3, model2);
+
+  /* "i_23 = i_11 + 1;"  */
+  region_model model4 (model3);
+  ASSERT_EQ (model4, model2);
+  model4.set_value (i, build2 (PLUS_EXPR, integer_type_node, i, int_1), &ctxt);
+  const svalue *plus_one = model4.get_rvalue (i, &ctxt);
+  /* TODO: what should this be?
+     Currently it's the widening(0, +ve) plus one.
+     Should it be a new widening(1, +ve), and apply a reworked version
+     of the constraints on the other widening value?  */
+  ASSERT_EQ (plus_one->get_kind (), SK_BINOP);
+
+  /* Try merging with the "i: 1" state.  */
+  region_model model5 (&mgr);
+  ASSERT_TRUE (model4.can_merge_with_p (model1, point, &model5));
+  ASSERT_EQ (model5.get_rvalue (i, &ctxt), plus_one);
+  ASSERT_EQ (model5, model4);
+
+  /*  "i_11 = PHI();" merge with state at phi above.
+      For i, we should have a merger of WIDENING with WIDENING + 1,
+      and this should be WIDENING again.  */
+  region_model model6 (&mgr);
+  ASSERT_TRUE (model5.can_merge_with_p (model2, point, &model6));
+  const svalue *merged_widening = model6.get_rvalue (i, &ctxt);
+  ASSERT_EQ (merged_widening->get_kind (), SK_WIDENING);
+  // FIXME: what constraints should we have here?
+
+  ASSERT_CONDITION_TRUE (model6, i, LT_EXPR, int_257);
+
+  /* This is a cache miss (we have i < 257 rather than i < 256).
+     However, on applying the loop-bound condition...
+     FIXME.  */
+
+  region_model model7_t (model6);
+  ADD_SAT_CONSTRAINT (model7_t, i, LT_EXPR, int_256);
+
+  region_model model7_f (model6);
+
+  //ASSERT_EQ (model6, model3);
+
+  // TODO: constraints at end of loop (with i >= 256; should get i == 256)
+  /* TODO: unittests for widening_svalue::eval_condition_without_cm
+     (separately).  */
+}
+
 /* Verify that if we mark a pointer to a malloc-ed region as non-NULL,
    all cast pointers to that region are also known to be non-NULL.  */
 
 static void
 test_malloc_constraints ()
 {
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   tree p = build_global_decl ("p", ptr_type_node);
   tree char_star = build_pointer_type (char_type_node);
   tree q = build_global_decl ("q", char_star);
   tree null_ptr = build_int_cst (ptr_type_node, 0);
 
-  region_id rid = model.add_new_malloc_region ();
-  svalue_id sid = model.get_or_create_ptr_svalue (ptr_type_node, rid);
-  model.set_value (model.get_lvalue (p, NULL), sid, NULL);
+  const svalue *size_in_bytes
+    = mgr.get_or_create_unknown_svalue (integer_type_node);
+  const region *reg = model.create_region_for_heap_alloc (size_in_bytes);
+  const svalue *sval = mgr.get_ptr_svalue (ptr_type_node, reg);
+  model.set_value (model.get_lvalue (p, NULL), sval, NULL);
   model.set_value (q, p, NULL);
 
-  /* We should have a symbolic_region with m_possibly_null: true.  */
-  region *pointee = model.get_region (rid);
-  symbolic_region *sym_reg = pointee->dyn_cast_symbolic_region ();
-  ASSERT_NE (sym_reg, NULL);
-  ASSERT_TRUE (sym_reg->m_possibly_null);
-
   ASSERT_CONDITION_UNKNOWN (model, p, NE_EXPR, null_ptr);
   ASSERT_CONDITION_UNKNOWN (model, p, EQ_EXPR, null_ptr);
   ASSERT_CONDITION_UNKNOWN (model, q, NE_EXPR, null_ptr);
